# Some defines for the Java subpackages
%define java5 1
%define icegridgui 1

# Get Python and Ruby packages into sitelib (see Fedora Wiki)
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%{!?ruby_sitelib: %define ruby_sitelib %(ruby -rrbconfig -e 'puts Config::CONFIG["sitelibdir"]')}
%{!?ruby_sitearch: %define ruby_sitearch %(ruby -rrbconfig -e 'puts Config::CONFIG["sitearchdir"]')}

Name: ice
Version: 3.2.1
Release: 17%{?dist}
Summary: The Ice base runtime and services

Group: System Environment/Libraries
License: GPLv2 with exceptions
URL: http://www.zeroc.com/
Source0:        http://www.zeroc.com/download/Ice/3.2/Ice-%{version}.tar.gz
Source1:        http://www.zeroc.com/download/Ice/3.2/Ice-rpmbuild-3.2.0.tar.gz
Source2:        http://www.zeroc.com/download/Ice/3.2/IceJ-%{version}-java5.tar.gz
Source3:        http://www.zeroc.com/download/Ice/3.2/IcePHP-%{version}.tar.gz
Source4:        http://www.zeroc.com/download/Ice/3.2/IcePy-%{version}.tar.gz
Source5:        http://www.zeroc.com/download/Ice/3.2/IceRuby-%{version}.tar.gz
Source6:        http://www.zeroc.com/download/Ice/3.2/IceCS-%{version}.tar.gz
Source7:        %{name}.pth
Source8:        icegridgui
Source9:        IceGridAdmin.desktop
Source10:       Ice-3.2.1-README.Fedora
Patch0:         Ice-3.2.0-chkconfig-runlevels.patch
Patch1:         Ice-3.2.0-chkconfig-pidfiles.patch
Patch2:         Ice-3.2.0-remove-assert.patch
Patch3:         IceJ-3.2.0-build-gui.patch
Patch4:         IceJ-3.2.0-use-java2.patch
Patch5:         IceJ-3.2.0-use-java5.patch
Patch6:         Ice-3.2.0-dont-build-test.patch
Patch7:         IceCS-3.2.1-dont-build-test.patch
Patch8:         IceCS-3.2.1-use-gac.patch
Patch9:         http://www.zeroc.com/forums/attachments/patches/527d1189575595-patch-1-ice-3-2-1-icedotnet-patch1.txt
Patch10:        http://www.zeroc.com/forums/attachments/patches/530d1190105491-patch-2-ice-3-2-1-fix-icegrid-application-update-bug-patch.txt
Patch11:        http://www.zeroc.com/forums/attachments/patches/531d1190619626-patch-3-ice-3-2-1-fix-slice2cs-ice-3.2.1-patch3.txt
Patch12:        http://www.zeroc.com/forums/attachments/patches/534d1192152933-patch-4-ice-3-2-1-fix-slice2cs-ice-3.2.1-patch4.txt
Patch13:        Ice-3.2.1-template-path.patch
Patch14:        http://www.zeroc.com/forums/attachments/patches/541d1194844106-1-attachment-s-patch-5-ice-3-2-1-fix-slice2cs-ice-3.2.1-patch5.txt
# Based on the Debian patch by Francisco Moya at 
# http://www.zeroc.com/forums/patches/3504-ice-c-missing-includes.html
Patch15:        Ice-3.2.1-gcc43.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# Ice doesn't officially support this architecture at all
ExcludeArch:    ppc64

# Some file suffixes we need to grab the right stuff for the file lists
%define soversion 32

BuildRequires: db4-devel, expat-devel, openssl-devel, bzip2-devel
BuildRequires: ant, ant-nodeps, jpackage-utils, db4-java
BuildRequires: php, php-devel
BuildRequires: ruby, ruby(abi) = 1.8, ruby-devel
BuildRequires: python-devel
BuildRequires: mono-core

%if %{java5}
BuildRequires:  java-devel >= 1.5.0
%else
BuildRequires:  java-devel >= 1.4.2
%endif

%if %{icegridgui}
BuildRequires:  jgoodies-forms, jgoodies-looks
BuildRequires:  /usr/bin/convert
BuildRequires:  desktop-file-utils
%endif

%description
Ice is a modern alternative to object middleware such as CORBA or
COM/DCOM/COM+.  It is easy to learn, yet provides a powerful network
infrastructure for demanding technical applications. It features an
object-oriented specification language, easy to use C++, C#, Java,
Python, Ruby, PHP, and Visual Basic mappings, a highly efficient
protocol, asynchronous method invocation and dispatch, dynamic
transport plug-ins, TCP/IP and UDP/IP support, SSL-based security, a
firewall solution, and much more.

# All of the other Ice packages also get built by this SRPM.

%package servers
Summary: Ice services to run through /etc/rc.d/init.d
Group: Development/Tools
Requires: ice = %{version}-%{release}
# Requirements for the users
Requires(pre): shadow-utils
# Requirements for the init.d services
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
%description servers
Ice services to run through /etc/rc.d/init.d

%package devel
Summary: Tools for developing Ice applications in C++
Group: Development/Tools
Provides: ice-c++-devel = %{version}-%{release}
Obsoletes: ice-c++-devel < %{version}-%{release}
Requires: ice = %{version}-%{release}
%description devel
Tools for developing Ice applications in C++.

%package java
Summary: The Ice runtime for Java
Group: System Environment/Libraries
%if %{java5}
Requires:       java >= 1.5.0
%else
Requires:       java >= 1.4.2
%endif
Requires: ice = %{version}-%{release}, db4-java
%description java
The Ice runtime for Java

%package java-devel
Summary: Tools for developing Ice applications in Java
Group: Development/Tools
Requires: ice-java = %{version}-%{release}
%description java-devel
Tools for developing Ice applications in Java.

%if %{icegridgui}
%package -n icegrid-gui
Summary: IceGrid Admin Tool
Group: Development/Tools
Requires: java
Requires: ice-java = %{version}-%{release}, ice = %{version}-%{release}
Requires: jgoodies-forms, jgoodies-looks
Requires: jpackage-utils
%description -n icegrid-gui
Graphical administration tool for IceGrid
%endif

%package csharp
Summary: The Ice runtime for C#
Group: System Environment/Libraries
Provides: ice-dotnet = %{version}-%{release}
Obsoletes: ice-dotnet < %{version}-%{release}
Requires: ice = %{version}-%{release}, mono-core >= 1.2.2
%description csharp
The Ice runtime for C#

%package csharp-devel
Summary: Tools for developing Ice applications in C#
Group: Development/Tools
Requires: ice-csharp = %{version}-%{release}, pkgconfig
%description csharp-devel
Tools for developing Ice applications in C#.

%package ruby
Summary: The Ice runtime for Ruby applications
Group: Development/Tools
Requires: ice = %{version}-%{release}, ruby(abi) = 1.8
%description ruby
The Ice runtime for Ruby applications.

%package ruby-devel
Summary: Tools for developing Ice applications in Ruby
Group: Development/Tools
Requires: ice-ruby = %{version}-%{release}
%description ruby-devel
Tools for developing Ice applications in Ruby.

%package python
Summary: The Ice runtime for Python applications
Group: Development/Tools
Requires: ice = %{version}-%{release}, python >= 2.3.4
%description python
The Ice runtime for Python applications.

%package python-devel
Summary: Tools for developing Ice applications in Python
Group: Development/Tools
Requires: ice-python = %{version}-%{release}
%description python-devel
Tools for developing Ice applications in Python.

%package php
Summary: The Ice runtime for PHP applications
Group: System Environment/Libraries
Requires: ice = %{version}-%{release}, php >= 5.1.4
%description php
The Ice runtime for PHP applications.

%prep
%setup -n Ice-%{version} -q
%patch6 -p1
%patch9 -p2
%patch10 -p2
%patch11 -p2
%patch12 -p2
%patch14 -p2
%patch15 -p1

# Fix some permission issues/
chmod a-x config/*.py
chmod a-x doc/images/*.gif

# Delete the pre-compiled .class file so we can rebuild it later
rm src/ca/ImportKey.class

%setup -c -q -n Ice-rpmbuild-%{version} -T -b 1
%patch0 -p1
%patch1 -p1
%patch13 -p1

%setup -q -n IceJ-%{version}-java5 -T -b 2
%patch2 -p1
%if %{icegridgui}
%patch3 -p1
%endif
%if %{java5}
%patch5 -p1
%else
%patch4 -p1
%endif

%setup -q -n IcePHP-%{version} -T -b 3
%setup -q -n IcePy-%{version} -T -b 4
%setup -q -n IceRuby-%{version} -T -b 5
%setup -q -n IceCS-%{version} -T -b 6
%patch7 -p1
%patch8 -p1

%build
# Compile the main Ice runtime
cd ${RPM_BUILD_DIR}/Ice-%{version}
make CXXFLAGS="%{optflags} -fPIC" CFLAGS="%{optflags} -fPIC" embedded_runpath_prefix=""

# Point to the newly-built ICE stuff so other compiles work
export ICE_HOME=$RPM_BUILD_DIR/Ice-%{version} 
export LD_LIBRARY_PATH=$ICE_HOME/lib:$LD_LIBRARY_PATH

# Set the CLASSPATH correctly for subsequent compiles
export CLASSPATH=`build-classpath db jgoodies-forms jgoodies-looks ant`

# Rebuild the Java class
cd src/ca
javac -source 1.4 -target 1.4 ImportKey.java

# Stuff for java-devel
cd $RPM_BUILD_DIR/IceJ-%{version}-java5/ant
rm *.class
javac -d . -source 1.4 -target 1.4 *.java
jar cvf ant-ice-%{version}.jar *.class

# Build the Java stuff
cd $RPM_BUILD_DIR/IceJ-%{version}-java5
ant clean
ant ice-jar

%if %{icegridgui}
ant icegridadmin-plain-jar
# Create a .png icon
cd resources/icons
convert icegrid.ico temp.png
mv temp-8.png icegrid.png
rm temp*.png
%endif

cd $RPM_BUILD_DIR/IceCS-%{version}
make OPTIMIZE=yes

cd $RPM_BUILD_DIR/IcePHP-%{version}
make CXXFLAGS="%{optflags} -fPIC" embedded_runpath_prefix=""
cd $RPM_BUILD_DIR/IcePy-%{version}
make CXXFLAGS="%{optflags} -fPIC" embedded_runpath_prefix=""
cd $RPM_BUILD_DIR/IceRuby-%{version}
make CXXFLAGS="%{optflags} -fPIC" embedded_runpath_prefix=""

%install
rm -rf $RPM_BUILD_ROOT

# Do the basic "make install"
cd $RPM_BUILD_DIR/Ice-%{version}
make prefix=$RPM_BUILD_ROOT embedded_runpath_prefix="" install
# We don't want visual basic :)
rm $RPM_BUILD_ROOT/bin/slice2vb

cd $RPM_BUILD_DIR/IcePy-%{version}
make ICE_HOME=$RPM_BUILD_DIR/Ice-%{version} prefix=$RPM_BUILD_ROOT embedded_runpath_prefix="" install

cd $RPM_BUILD_DIR/IcePHP-%{version}
make ICE_HOME=$RPM_BUILD_DIR/Ice-%{version} prefix=$RPM_BUILD_ROOT install

cd $RPM_BUILD_DIR/IceRuby-%{version}
make OPTIMIZE=yes ICE_HOME=$RPM_BUILD_DIR/Ice-%{version} prefix=$RPM_BUILD_ROOT embedded_runpath_prefix="" install

# Install Java stuff where it wants to be
mkdir -p ${RPM_BUILD_ROOT}%{_javadir}
cp -p ${RPM_BUILD_DIR}/IceJ-%{version}-java5/lib/Ice.jar ${RPM_BUILD_ROOT}%{_javadir}/Ice-%{version}.jar
ln -s Ice-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/Ice.jar

# Install the GUI if we need it
%if %{icegridgui}
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/Ice-%{version}
cp -p ${RPM_BUILD_DIR}/IceJ-%{version}-java5/lib/IceGridGUI.jar ${RPM_BUILD_ROOT}%{_datadir}/Ice-%{version}
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/icons/hicolor/48x48/apps/
cp -p ${RPM_BUILD_DIR}/IceJ-%{version}-java5/resources/icons/icegrid.png \
        ${RPM_BUILD_ROOT}%{_datadir}/icons/hicolor/48x48/apps/
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
cp -p %{SOURCE8} ${RPM_BUILD_ROOT}%{_bindir}
sed -i -e "s#DIR#%{_datadir}/Ice-%{version}#" $RPM_BUILD_ROOT%{_bindir}/icegridgui
desktop-file-install \
        --dir=${RPM_BUILD_ROOT}%{_datadir}/applications \
        %{SOURCE9}
%endif

# Install the Mono stuff, using gacutil
cd $RPM_BUILD_DIR/IceCS-%{version}
mkdir $RPM_BUILD_ROOT%{_prefix}/lib
make ICE_HOME=$RPM_BUILD_DIR/Ice-%{version} prefix=$RPM_BUILD_ROOT GAC_ROOT=$RPM_BUILD_ROOT%{_libdir} install

mkdir -p $RPM_BUILD_ROOT%{_bindir}
mv $RPM_BUILD_ROOT/bin/iceboxnet.exe $RPM_BUILD_ROOT%{_bindir}

# "Cleanup extra files" (from original ZeroC SRPM)
rm    $RPM_BUILD_ROOT/config/Make.rules.cs

# Move other rpm-specific files into the right place (README, service stuff)
mkdir -p $RPM_BUILD_ROOT%{_defaultdocdir}/Ice-%{version}
cp -p %{SOURCE10} $RPM_BUILD_ROOT/%{_defaultdocdir}/Ice-%{version}/README.Fedora
cp -p $RPM_BUILD_DIR/Ice-rpmbuild-%{version}/ice.ini $RPM_BUILD_ROOT/ice.ini

# Install the servers
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
cp -p $RPM_BUILD_DIR/Ice-rpmbuild-%{version}/*.conf $RPM_BUILD_ROOT%{_sysconfdir}
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
for i in icegridregistry icegridnode glacier2router
do
    cp -p $RPM_BUILD_DIR/Ice-rpmbuild-%{version}/$i.%{_vendor} $RPM_BUILD_ROOT%{_initrddir}/$i
done
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/icegrid

# "make install" assumes it's going into a directory under /opt.
# Move things to where they should be in an RPM setting (adapted from
# the original ZeroC srpm).
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mv $RPM_BUILD_ROOT/bin/* $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_includedir}
mv $RPM_BUILD_ROOT/include/* ${RPM_BUILD_ROOT}%{_includedir}
mkdir -p $RPM_BUILD_ROOT%{_libdir}
mv $RPM_BUILD_ROOT/%{_lib}/* $RPM_BUILD_ROOT%{_libdir}

# .NET spec files (for csharp-devel)
mkdir -p $RPM_BUILD_ROOT%{_libdir}/pkgconfig

for f in icecs glacier2cs iceboxcs icegridcs icepatch2cs icestormcs; 
do 
    cp -p $RPM_BUILD_DIR/IceCS-%{version}/lib/pkgconfig/$f.pc $RPM_BUILD_ROOT%{_libdir}/pkgconfig 
done

# Put the PHP stuff into the right place
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/php.d
mv $RPM_BUILD_ROOT/ice.ini $RPM_BUILD_ROOT%{_sysconfdir}/php.d
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/php/modules
mv ${RPM_BUILD_ROOT}%{_libdir}/IcePHP.so ${RPM_BUILD_ROOT}%{_libdir}/php/modules

# Also Ruby and Python -- remove all shebang lines while we're at it
for f in $RPM_BUILD_ROOT/python/Ice.py $RPM_BUILD_ROOT/ruby/*.rb;
do
    grep -v '/usr/bin/env' $f > $f.tmp
    mv $f.tmp $f
done
mkdir -p ${RPM_BUILD_ROOT}%{ruby_sitearch}
mv $RPM_BUILD_ROOT/ruby/* ${RPM_BUILD_ROOT}%{ruby_sitearch}
mkdir -p ${RPM_BUILD_ROOT}%{python_sitearch}/Ice
cp -p %{SOURCE7} $RPM_BUILD_ROOT%{python_sitearch}
mv ${RPM_BUILD_ROOT}/python/IcePy.so* ${RPM_BUILD_ROOT}%{python_sitearch}/Ice
mkdir -p ${RPM_BUILD_ROOT}%{python_sitelib}/Ice
cp -p %{SOURCE7} $RPM_BUILD_ROOT%{python_sitelib}
mv ${RPM_BUILD_ROOT}/python/* ${RPM_BUILD_ROOT}%{python_sitelib}/Ice

mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/Ice-%{version}
mv $RPM_BUILD_ROOT/config/* ${RPM_BUILD_ROOT}%{_datadir}/Ice-%{version}
mv $RPM_BUILD_ROOT/slice ${RPM_BUILD_ROOT}%{_datadir}/Ice-%{version}
# Somehow, some files under "slice" end up with executable permissions -- ??
find ${RPM_BUILD_ROOT}%{_datadir}/Ice-%{version} -name "*.ice" | xargs chmod a-x
# Move ImportKey.class into the share directory
mv $RPM_BUILD_ROOT%{_bindir}/ImportKey.class ${RPM_BUILD_ROOT}%{_datadir}/Ice-%{version}

mkdir -p ${RPM_BUILD_ROOT}%{_defaultdocdir}/Ice-%{version}
mv $RPM_BUILD_ROOT/doc/reference ${RPM_BUILD_ROOT}%{_defaultdocdir}/Ice-%{version}
rm -rf $RPM_BUILD_ROOT/doc
mv $RPM_BUILD_ROOT/ICE_LICENSE ${RPM_BUILD_ROOT}%{_defaultdocdir}/Ice-%{version}/ICE_LICENSE
mv $RPM_BUILD_ROOT/LICENSE ${RPM_BUILD_ROOT}%{_defaultdocdir}/Ice-%{version}/LICENSE

# Copy the Ant task files into the right place
mkdir -p ${RPM_BUILD_ROOT}%{_javadir}
cp -p -r ${RPM_BUILD_DIR}/IceJ-%{version}-java5/ant/ant-ice-%{version}.jar ${RPM_BUILD_ROOT}%{_javadir}
ln -s ant-ice-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/ant-ice.jar

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%{_defaultdocdir}/Ice-%{version}
%{_bindir}/dumpdb
%{_bindir}/transformdb
%{_bindir}/glacier2router
%{_bindir}/icebox
%{_bindir}/iceboxadmin
%{_bindir}/icecpp
%{_bindir}/icepatch2calc
%{_bindir}/icepatch2client
%{_bindir}/icepatch2server
%{_bindir}/icestormadmin
%{_bindir}/slice2docbook
%{_bindir}/slice2html
%{_bindir}/icegridadmin
%{_bindir}/icegridnode
%{_bindir}/icegridregistry
%{_bindir}/iceca
%{_libdir}/libFreeze.so.%{version}
%{_libdir}/libFreeze.so.%{soversion}
%{_libdir}/libGlacier2.so.%{version}
%{_libdir}/libGlacier2.so.%{soversion}
%{_libdir}/libIceBox.so.%{version}
%{_libdir}/libIceBox.so.%{soversion}
%{_libdir}/libIcePatch2.so.%{version}
%{_libdir}/libIcePatch2.so.%{soversion}
%{_libdir}/libIce.so.%{version}
%{_libdir}/libIce.so.%{soversion}
%{_libdir}/libIceSSL.so.%{version}
%{_libdir}/libIceSSL.so.%{soversion}
%{_libdir}/libIceStormService.so.%{version}
%{_libdir}/libIceStormService.so.%{soversion}
%{_libdir}/libIceStorm.so.%{version}
%{_libdir}/libIceStorm.so.%{soversion}
%{_libdir}/libIceUtil.so.%{version}
%{_libdir}/libIceUtil.so.%{soversion}
%{_libdir}/libIceXML.so.%{version}
%{_libdir}/libIceXML.so.%{soversion}
%{_libdir}/libSlice.so.%{version}
%{_libdir}/libSlice.so.%{soversion}
%{_libdir}/libIceGrid.so.%{version}
%{_libdir}/libIceGrid.so.%{soversion}
%dir %{_datadir}/Ice-%{version}
%{_datadir}/Ice-%{version}/slice
%{_datadir}/Ice-%{version}/templates.xml
%{_datadir}/Ice-%{version}/ImportKey.class
%attr(755,root,root) %{_datadir}/Ice-%{version}/convertssl.py*
%attr(755,root,root) %{_datadir}/Ice-%{version}/upgradeicegrid.py*
%attr(755,root,root) %{_datadir}/Ice-%{version}/upgradeicestorm.py*
%{_datadir}/Ice-%{version}/icegrid-slice.3.1.ice.gz

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files servers
%defattr(-,root,root,-)
%{_initrddir}/icegridregistry
%{_initrddir}/icegridnode
%{_initrddir}/glacier2router
%config(noreplace) %{_sysconfdir}/icegridregistry.conf
%config(noreplace) %{_sysconfdir}/icegridnode.conf
%config(noreplace) %{_sysconfdir}/glacier2router.conf
%dir %{_localstatedir}/lib/icegrid

%pre servers
# Following the Wiki instructions ...
getent group iceuser > /dev/null || groupadd -r iceuser
getent passwd iceuser > /dev/null || \
        useradd -r -g iceuser -d %{_localstatedir}/lib/icegrid \
        -s /sbin/nologin -c "IceGrid server user" iceuser
exit 0

%post servers
/sbin/chkconfig --add icegridregistry
/sbin/chkconfig --add icegridnode
/sbin/chkconfig --add glacier2router

%preun servers
if [ $1 = 0 ]; then
        /sbin/service icegridregistry stop >/dev/null 2>&1 || :
        /sbin/chkconfig --del icegridregistry
        /sbin/service icegridnode stop >/dev/null 2>&1 || :
        /sbin/chkconfig --del icegridnode
        /sbin/service glacier2router stop >/dev/null 2>&1 || :
        /sbin/chkconfig --del glacier2router
fi

%postun servers
if [ "$1" -ge "1" ]; then
        /sbin/service icegridregistry condrestart >/dev/null 2>&1 || :
        /sbin/service icegridnode condrestart >/dev/null 2>&1 || :
        /sbin/service glacier2router condrestart >/dev/null 2>&1 || :
fi

%files devel
%defattr(-, root, root, -)
%{_bindir}/slice2cpp
%{_bindir}/slice2freeze
%{_includedir}/Freeze
%{_includedir}/Glacier2
%{_includedir}/Ice
%{_includedir}/IceBox
%{_includedir}/IceGrid
%{_includedir}/IcePatch2
%{_includedir}/IceSSL
%{_includedir}/IceStorm
%{_includedir}/IceUtil
%{_includedir}/IceXML
%{_includedir}/Slice
%{_libdir}/libFreeze.so
%{_libdir}/libGlacier2.so
%{_libdir}/libIceBox.so
%{_libdir}/libIceGrid.so
%{_libdir}/libIcePatch2.so
%{_libdir}/libIce.so
%{_libdir}/libIceSSL.so
%{_libdir}/libIceStormService.so
%{_libdir}/libIceStorm.so
%{_libdir}/libIceUtil.so
%{_libdir}/libIceXML.so
%{_libdir}/libSlice.so

%files java
%defattr(-,root,root,-)
%{_javadir}/Ice-%{version}.jar
%{_javadir}/Ice.jar

%if %{icegridgui}
%files -n icegrid-gui
%defattr(-,root,root,-)
%{_datadir}/Ice-%{version}/IceGridGUI.jar
%attr(755,root,root) %{_bindir}/icegridgui
%{_datadir}/applications/IceGridAdmin.desktop
%{_datadir}/icons/hicolor/48x48/apps/icegrid.png
%endif

%files java-devel
%defattr(-,root,root,-)
%{_bindir}/slice2java
%{_bindir}/slice2freezej
%{_javadir}/ant-ice-%{version}.jar
%{_javadir}/ant-ice.jar

%files csharp
%defattr(-,root,root,-)
%dir %{_libdir}/mono/gac/glacier2cs
%{_libdir}/mono/gac/glacier2cs/%{version}.*/
%{_libdir}/mono/glacier2cs/
%dir %{_libdir}/mono/gac/icecs
%{_libdir}/mono/gac/icecs/%{version}.*/
%{_libdir}/mono/icecs/
%dir %{_libdir}/mono/gac/iceboxcs
%{_libdir}/mono/gac/iceboxcs/%{version}.*/
%{_libdir}/mono/iceboxcs/
%dir %{_libdir}/mono/gac/icegridcs
%{_libdir}/mono/gac/icegridcs/%{version}.*/
%{_libdir}/mono/icegridcs/
%dir %{_libdir}/mono/gac/icepatch2cs
%{_libdir}/mono/gac/icepatch2cs/%{version}.*/
%{_libdir}/mono/icepatch2cs/
%dir %{_libdir}/mono/gac/icestormcs
%{_libdir}/mono/gac/icestormcs/%{version}.*/
%{_libdir}/mono/icestormcs/
%{_bindir}/iceboxnet.exe

%files csharp-devel
%defattr(-,root,root,-)
%{_bindir}/slice2cs
%{_libdir}/pkgconfig/icecs.pc
%{_libdir}/pkgconfig/glacier2cs.pc
%{_libdir}/pkgconfig/iceboxcs.pc
%{_libdir}/pkgconfig/icegridcs.pc
%{_libdir}/pkgconfig/icepatch2cs.pc
%{_libdir}/pkgconfig/icestormcs.pc

%files python
%defattr(644,root,root,755)
%ifarch x86_64 ppc64
%{python_sitearch}/Ice/
%{python_sitearch}/%{name}.pth
%endif
%{python_sitelib}/Ice/
%{python_sitelib}/%{name}.pth

%files python-devel
%defattr(-,root,root,-)
%{_bindir}/slice2py

%files ruby
%defattr(644,root,root,755)
%{ruby_sitearch}/*

%files ruby-devel
%defattr(-,root,root,-)
%{_bindir}/slice2rb

%files php
%defattr(-,root,root,-)
%{_libdir}/php/modules/IcePHP.so
%config(noreplace) %{_sysconfdir}/php.d/ice.ini

%changelog
* Fri Feb 22 2008 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-17
- Improved, less invasive patch based on the Debian one

* Fri Feb 22 2008 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-16
- Add includes so that it compiles with GCC 4.3

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 3.2.1-15
- Autorebuild for GCC 4.3

* Wed Dec 05 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-14
- Version bump to rebuild because of changed OpenSSL in rawhide

* Tue Nov 20 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-13
- Enable the IceGrid GUI
- Fix a problem with Python on 64-bit systems (bz #392751)
- Incorporate one more Mono patch from ZeroC

* Tue Oct 30 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-12
- Put the slice2java classes into a .jar file instead of as bare classes
- Incorporate all Ice 3.2.1 patches from ZeroC
- Fix templates path in icegridregistry.conf

* Fri Sep  7 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-11
- Also add Obsoletes: for the old zeroc names
- Fix bad date in changelog

* Wed Aug 29 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-9
- Add "with exceptions" to license tag
- Minor typo corrections in README.Fedora
- Move ruby sitearch files out of an "Ice/" subdirectory so that they're
  actually useful

* Tue Aug 28 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-8
- Remove parallel make to see if that fixes build errors

* Mon Aug 27 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-7
- Fix over-zealous patch in csharp IceBox Makefile

* Mon Aug 27 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-6
- Put IcePy.so* into sitearch, not sitelib
- Use %%ifarch in python file list to avoid duplicate warnings
- Actually use gacutil for the Mono dlls instead of faking it

* Fri Aug 24 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-5
- Clean up packaging of icegridgui: it's a gui app, so we should treat it as
  such (NB: building this package is still disabled by default because it needs
  jgoodies)
- Actually create the working directory for the Ice services
- Remove redundant requires on java-devel and csharp-devel packages
- Fix file list for python package to own directories too
- Modified the README to accurately reflect what's in the Fedora package

* Thu Aug 23 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-4
- Whoops, ruby(abi) doesn't pull in ruby ...
- Redirect getent output to /dev/null
- Try again to remove execute permission on all *.ice files (????)
- Move ImportKey.class out of bin and into share (not sure what it does, but I'm
  pretty sure it doesn't belong in bin!)

* Wed Aug 22 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-3
- Changed BuildRequires on ruby to ruby(abi) = 1.8
- Fixed all dependencies between subpackages: everything requires the base
  package, and -devel packages should all require their corresponding non-devel
  package now
- Made ice-csharp require pkgconfig
- Modified the user/group creation process based on the wiki
- Removed ldconfig for ice-c++-devel subpackage
- Made the python_sitelib subdirectory owned by ice-python
- Removed executable permission on all files under slice (how did that happen?)
- Fixed typo on ice-csharp group
- Changed license tag to GPLv2
- Removed macros in changelog
- Set CFLAGS as well as CPPFLAGS for make so that building icecpp gets the 
  correct flags too
- Renamed ice-c++-devel to ice-devel
- Added Provides: for ice-c++-devel and ice-dotnet for people moving from the
  ZeroC RPMs
- Also don't build "test" or "demo" for IceCS

* Sun Aug 18 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-2
- ExcludeArch ppc64
- Fix one more hard-coding problem for x86_64

* Thu Aug 16 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.1-1
- Update to 3.2.1

* Wed Aug  1 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.0-7
- Fixed arch-specific issues:
  - %%ifnarch ppc64 in a lot of places; it doesn't have db4-java or mono-core,
    so no Java or CSharp packages
  - Replaced one literal "lib" with %%{_lib}
- Added IceGrid registry patch from ZeroC forum
- Don't build "test" or "demo" subdirectories
- Use "/sbin/ldconfig" instead of %%{_sbindir} because that's /usr/sbin (also
  for other things like /sbin/service etc)
- Removed useless "dotnetversion" define (it's the same as "version")
- Remove executable bit on all "*.ice" files (it gets set somehow on a few)

* Tue Jul 31 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.0-6
- Updated to incorporate more suggestions from Mamoru Tasaka (sorry for the delay!)
- Include Java and C# stuff in the single SRPM (NB: they'll no longer be noarch)

* Mon Jul  9 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.0-5
- Updated following review comments from Mamoru Tasaka
- Renamed file to "ice.spec"
- Use %%{_libdir} instead of literal "lib"/"lib64" (not yet tested on 64-bit
  system)
- Changed "make" calls to use the correct compiler flags (including -fPIC)
- Changed "cp" to "cp -p" everywhere for timestamps
- Use more macros instead of hard-coded directory names: 
  %%_prefix, %%_libdir, %%_initrddir, %%_localstatedir, %%_sbindir
- Un-excluded *.pyo files

* Wed Jun 13 2007 Mary Ellen foster <mefoster at gmail.com> 3.2.0-4
- Removed cruft so that it no longer tries to build Java stuff (whoops)

* Wed Apr 18 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.0-3
- Use RPM macros instead of /etc and /usr/bin (Thanks to Peter Lemenkov)
- Suggestions from ZeroC forum (http://zeroc.com/forums/showthread.php?t=3095):
  - Use Python site-packages directory
  - Create "iceuser" user
  - Split /etc/init.d services into a separate sub-package
- Follow guidelines from Fedora wiki about packaging Ruby
  - Use Ruby site-arch directory
  - Depend on ruby(abi)
- Make sure to compile all Java files with -source 1.4 -target 1.4

* Wed Apr 11 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.0-2
- Remove "assert" in Java classes for compilation with Java 1.4

* Fri Mar 30 2007 Mary Ellen Foster <mefoster at gmail.com> 3.2.0-1
- Initial spec, based on spec distributed by ZeroC
